package nr.chordCheck;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import javax.swing.JPanel;

import nr.music.Chord;
import nr.music.ChordSymbol;
import nr.music.chordprovider.ChordProviderEvent;
import nr.music.chordprovider.ChordProviderListener;

@SuppressWarnings("serial")
public class ChordPanel extends JPanel implements ChordProviderListener {
//	static private Category log = Category.getInstance(ChordPanel.class);
	private ChordSymbol chordSymbol;

	public ChordPanel() {
		setPreferredSize(new Dimension(800, 400));
	}

	public void setChord(Chord chord) {
		if (chord == null) {
			chordSymbol = null;
		} else {
			chordSymbol = chord.getSymbol();
			chordSymbol.setBackGroundColor(getBackground());
			chordSymbol.setForeGroundColor(getForeground());
		}
		repaint();
	}

	public void paint(Graphics g) {
		int height = getHeight();
		int width = getWidth();
		g.setColor(getBackground());
		g.fillRect(0, 0, width, height);
		if (chordSymbol == null)
			return;
		BufferedImage symbolImage = chordSymbol.getSymbolImage();
		int imageHeight = symbolImage.getHeight();
		int imageWidth = symbolImage.getWidth();
		float factor = Math.min((float) height / (float) imageHeight, (float) width / (float) imageWidth);
		int newWidth = (int) (imageWidth * factor);
		int newHeight = (int) (imageHeight * factor);
		g.drawImage(symbolImage, (width - newWidth) / 2, (height - newHeight) / 2, newWidth, newHeight, Color.LIGHT_GRAY, null);
	}

	public void chordChanged(ChordProviderEvent chordEvent) {
		setChord(chordEvent.getChord());
	}
}
