package nr.chordEnter;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JPanel;

import nr.chordCheck.Checker;

import org.apache.log4j.Logger;

public class CleffPanel extends JPanel
{
private static final long					serialVersionUID	= 1L;
private static final Logger log = Logger.getLogger(Checker.class);

private Image								m_background		= null;

private EnterChords							s_parent			= null;

private static int 							Y_GROUND 			= 214;
private static int 							y_lineDistance 		= 8;
private static int 							y_offset 			= y_lineDistance/2;

//private int									m_iWholeStep		= 16;
//private int									m_iHalfStep			= 8;
//private int									m_iMiddleCStep		= 192;
//private Rectangle							m_rectSteps			= new Rectangle(107, m_iMiddleCStep
//																	- (8 * m_iWholeStep), 418,
//																		(m_iWholeStep * m_iWholeStep) - 1);


public CleffPanel(final EnterChords parentFrame)
{
	super(null);
	
	s_parent = parentFrame;
	
	this.setDoubleBuffered(false);
	this.setIgnoreRepaint(true);
	this.setOpaque(true);

	try
	{
		/*  Use class resource retrieval method if you want to package everything within one jar  */
		//m_background = ImageIO.read(ClassLoader.getSystemResourceAsStream("data/img/oldpaper_notes.gif"));
					
		m_background = ImageIO.read(new File("data/img/oldpaper_notes.gif"));
	}
	catch (IOException e1)
	{
		log.debug("Error loading GIF image [oldpaper_notes.gif]");
		e1.printStackTrace();
	}

	this.setLayout(null);

	Dimension dim = new Dimension(m_background.getWidth(null), m_background.getHeight(null) - 1);

	this.setMinimumSize(dim);
	this.setPreferredSize(dim);
	this.setBounds(0, 0, m_background.getWidth(null), m_background.getHeight(null));
	this.setFont(new Font("Courier", Font.BOLD, 19));
	
}

@Override
public void paintComponent(Graphics g)
{
	super.paintComponent(g);
			
	Graphics2D g2 = (Graphics2D) g;

	/* Plain "old paper" texture */
	g2.drawImage(m_background, 0, 0, null);
	
	drawNotes(g2);
	
}																

private void drawNotes(Graphics2D g)
{
	g.setColor(Color.black);
	GenericNote note;
	
	s_parent.m_iTmpIterator = 0;
	
	while ((note = s_parent.nextNote()) != null)
	{
		note.draw(g);
		//log.debug("Index: " + note.getNoteIndex());
	}
}

/*  calculates the correct note according to the given position of mouse click on lines  */
public void calcNoteFromPosition(GenericNote note, int x, int y)
{
	int keyIndex;
	int octave;
	int bassClef;
	int y_rest;		
	int y_value = Y_GROUND - y + y_offset;
			
	if (y_value > 0) {
		octave = (Y_GROUND - y + y_offset) / (y_lineDistance*7);
		y_rest = (Y_GROUND - y + y_offset) % (y_lineDistance*7);
		keyIndex = y_rest / y_lineDistance;
		bassClef=0;
	} else {
		octave = (Y_GROUND - y + y_offset) / (y_lineDistance*7) -1 ;
		y_rest = (y - Y_GROUND - y_offset) % (y_lineDistance*7);
		keyIndex = 6 - (y_rest / y_lineDistance);
		bassClef=1;
	}
	
	log.debug("KeyIndex: " + keyIndex);
	log.debug("y_value: " + y_rest);
	log.debug("Octave: " + octave);
	log.debug("calcNote: " + note.m_keyArray[keyIndex]);	
	log.debug("octave*y_lineDistance*7 : " + octave*y_lineDistance*7);
	log.debug("keyIndex * y_lineDistance: " + keyIndex * y_lineDistance);
	
	if (y_value > 0) {
		log.debug("y_offset" + (Y_GROUND - y_offset - 26 - octave*y_lineDistance*7 - keyIndex * y_lineDistance));
		note.setYPos(Y_GROUND - y_offset - 26 - octave*y_lineDistance*7 - keyIndex * y_lineDistance);
	} else {
		log.debug("y_offset" + (Y_GROUND + y_offset - 26 - (octave+1)*y_lineDistance*7 + (6-keyIndex) * y_lineDistance));
		note.setYPos(Y_GROUND + y_offset - 26 - (octave+1)*y_lineDistance*7 + (6-keyIndex) * y_lineDistance);
	}
	note.setXPos(x-15); /* TODO */
	note.m_noteName=note.m_keyArray[keyIndex];
	note.m_iOctave=octave;
	note.m_bassClef=bassClef;
	note.m_sAccidental[0]=EnterChords.m_globalState;	
	note.m_iStepsFromC=calcStepsFromC(note);
}

	public int calcStepsFromC( GenericNote note )
	{
		log.debug("function now calcs the steps from the middle C" );
		int iSteps=0;
		int iIndex;
		String sConvName = note.m_noteName + note.m_sAccidental[0] ;
		
		iIndex=EnterChords.getNoteIndex(note);	
		log.debug("iIndex = " + iIndex);
		log.debug("note.m_iOctave = " + note.m_iOctave);
		
		iSteps=((note.m_iOctave) * 12 + iIndex);
				
		log.debug("iSteps = " + iSteps);
		return iSteps;
	}


}



