package nr.chordEnter;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Label;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JRadioButton;

import nr.chordCheck.Checker;

import org.apache.log4j.Logger;


public class ConfPanel extends JFrame implements MouseListener,ItemListener {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static final Logger log = Logger.getLogger(Checker.class);
	
	private TextField  		m_textFieldUpperLine	= null;
	private TextField  		m_textFieldBaseLine		= null;
	private TextField  		m_textFieldChordName 	= null;
	private TextField  		m_textFieldChordLabel	= null;
	
	public ConfPanel(final EnterChords parentFrame)
	{	
		
		this.addMouseListener(this);	
		this.setUndecorated(false);
		this.setResizable(false);
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.setModalExclusionType(null);
		
		Dimension dim = new Dimension(250, 200);
		this.setMinimumSize(dim);
		this.setPreferredSize(dim);
		this.setBounds(0, 0, 50, 200);
		this.setFont(new Font("Courier", Font.BOLD, 19));
		
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		
		setLayout(gbl);
		
		Font fontBold = new Font("Serif", Font.BOLD, 14);
		Font fontPlain = new Font("Serif", Font.PLAIN, 12);	
		
		// Label:
		gbc = makegbc(0,0,1,1);
		gbc.fill = GridBagConstraints.NONE;
		Label labelAcc = new Label("Accidentals:");
		labelAcc.setFont(fontBold);
		gbl.addLayoutComponent(labelAcc,gbc);
		add(labelAcc);
		
		// Radio Buttons:		
		gbc = makegbc(0,1,1,1);
		gbc.weightx = 130;
		gbc.fill = GridBagConstraints.NONE;
		JRadioButton jRadioButtonNone = new JRadioButton("none");
		jRadioButtonNone.setFont(fontPlain);
		gbl.addLayoutComponent(jRadioButtonNone,gbc);
		add(jRadioButtonNone);
		
		gbc = makegbc(1,1,1,1);
		gbc.weightx = 130;
		gbc.fill = GridBagConstraints.NONE;
		JRadioButton jRadioButtonFlat = new JRadioButton("b");	
		jRadioButtonFlat.setFont(fontPlain);
		gbl.addLayoutComponent(jRadioButtonFlat,gbc);
		add(jRadioButtonFlat);	
		
		gbc = makegbc(2,1,1,1);
		gbc.weightx = 130;
		gbc.fill = GridBagConstraints.NONE;
		JRadioButton jRadioButtonSharp = new JRadioButton("#");
		jRadioButtonSharp.setFont(fontPlain);
		gbl.addLayoutComponent(jRadioButtonSharp,gbc);
		add(jRadioButtonSharp);
		
//		JCheckBox jCheckBoxBaseNote = new JCheckBox("set base");
//		jCheckBoxBaseNote.addItemListener(this);
//		this.add(jCheckBoxBaseNote);
		
		Dimension dimTextField = new Dimension();
		dimTextField.height = 15;
		dimTextField.width = 130;
		
		int nrOfColumns=10;
		
		// Labels:
		gbc = makegbc(0,2,1,1);
		gbc.weightx = 130;
		gbc.fill = GridBagConstraints.NONE;
		Label chordLabel = new Label("Chord label:");
		chordLabel.setSize(dimTextField);
		chordLabel.setFont(fontBold);
		chordLabel.setAlignment(Label.LEFT);
		gbl.setConstraints(chordLabel,gbc);
		add(chordLabel);

		//Input field:
		gbc = makegbc(1,2,1,1);
		gbc.weightx = 130;
		gbc.fill = GridBagConstraints.NONE;
		m_textFieldChordLabel = new TextField("label",nrOfColumns);
		m_textFieldChordLabel.setSize(dimTextField);
		gbl.setConstraints(m_textFieldChordLabel,gbc);
		add(m_textFieldChordLabel);
		
		// Label:
		gbc = makegbc(0,3,1,1);
		gbc.weightx = 130;
		gbc.fill = GridBagConstraints.NONE;
		Label chordLabelUpperLine = new Label("Upper line:");
		chordLabelUpperLine.setSize(dimTextField);
		chordLabelUpperLine.setAlignment(Label.LEFT);
		gbl.setConstraints(chordLabelUpperLine,gbc);
		add(chordLabelUpperLine);

		//Input field:
		gbc = makegbc(1,3,1,1);
		gbc.weightx = 130;
		gbc.fill = GridBagConstraints.NONE;
		m_textFieldUpperLine = new TextField("b7/add9",nrOfColumns);
		m_textFieldUpperLine.setSize(dimTextField);
		gbl.setConstraints(m_textFieldUpperLine,gbc);
		add(m_textFieldUpperLine);
		
		gbc = makegbc(0,4,1,1);
		gbc.weightx = 130;
		gbc.fill = GridBagConstraints.NONE;
		Label chordLabelChordName = new Label("Chord name:");
		chordLabelChordName.setSize(dimTextField);
		chordLabelChordName.setAlignment(Label.LEFT);
		gbl.setConstraints(chordLabelChordName,gbc);
		add(chordLabelChordName);
		
		//Input field:
		gbc = makegbc(1,4,1,1);
		gbc.weightx = 130;
		gbc.fill = GridBagConstraints.NONE;
		m_textFieldChordName = new TextField("MA",nrOfColumns);
		m_textFieldChordName.setSize(dimTextField);
		gbl.setConstraints(m_textFieldChordName,gbc);
		add(m_textFieldChordName);
		
		gbc = makegbc(0,5,1,1);
		gbc.weightx = 130;
		gbc.fill = GridBagConstraints.NONE;
		Label chordLabelBaseLine = new Label("Base line:");
		chordLabelBaseLine.setSize(dimTextField);
		chordLabelBaseLine.setAlignment(Label.LEFT);
		gbl.setConstraints(chordLabelBaseLine,gbc);
		add(chordLabelBaseLine);
				
		//Input field:
		gbc = makegbc(1,5,1,1);
		gbc.weightx = 130;
		gbc.fill = GridBagConstraints.NONE;
		m_textFieldBaseLine = new TextField("Ev5:",nrOfColumns);
		m_textFieldBaseLine.setSize(dimTextField);
		gbl.setConstraints(m_textFieldBaseLine,gbc);
		add(m_textFieldBaseLine);
		
		jRadioButtonNone.setSelected(true);
		
		//Group the radio buttons.
	    ButtonGroup group = new ButtonGroup();
	    group.add(jRadioButtonNone);
	    group.add(jRadioButtonFlat);
	    group.add(jRadioButtonSharp);		
	    
	    this.setVisible(true);
	    
	    jRadioButtonNone.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0)
			{
				log.debug("Button None pressed!");
				EnterChords.m_globalState="";
			}			
		});
	    
		jRadioButtonFlat.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0)
			{
				log.debug("Button Flat pressed!");
				EnterChords.m_globalState="b";
			}			
		});
		
		jRadioButtonSharp.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0)
			{
				log.debug("Button Sharp pressed!");
				EnterChords.m_globalState="#";
			}			
		});
	
		
	}
	
	public TextField getM_textFieldBaseLine() {
		return m_textFieldBaseLine;
	}

	public void setM_textFieldBaseLine(TextField fieldBaseLine) {
		m_textFieldBaseLine = fieldBaseLine;
	}
	
	public TextField getM_textFieldUpperLine() {
		return m_textFieldUpperLine;
	}

	public void setM_textFieldUpperLine(TextField fieldUpperLine) {
		m_textFieldUpperLine = fieldUpperLine;
	}

	private GridBagConstraints 
	makegbc (int x, int y, int width, int height)
	{
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.insets = new Insets( 1 ,1 ,1 ,1 );
		return gbc;
	}
	
	@Override
	public void mouseClicked(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseEntered(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void itemStateChanged(ItemEvent e) {
        e.getItemSelectable(); 
        if (e.getStateChange() == ItemEvent.DESELECTED) {
			EnterChords.setM_setBaseNoteFlag(false);
			log.debug("jRadioButtonBaseNote set to FALSE!");
        } else {
			EnterChords.setM_setBaseNoteFlag(true);
			log.debug("jRadioButtonBaseNote set to TRUE!");
        }
	}

	public TextField getM_textFieldChordName() {
		return m_textFieldChordName;
	}
	
	public TextField getM_textFieldChordLabel() {
		return m_textFieldChordLabel;
	}
	
}
