package nr.chordEnter;

import java.awt.Color;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import nr.chordCheck.Checker;

import org.apache.log4j.Logger;

public class GenericKey extends Component implements MouseListener
{
	private static final long	serialVersionUID	= 1L;
    private static final Logger log = Logger.getLogger(Checker.class);

	public final boolean		KEY_DOWN			= true;
	public final boolean		KEY_UP				= false;

	protected String[]			m_sArrID			= null;
	protected int				m_iOctave			= 0;

	private int					m_iKeyWidth			= 20;
	private int					m_iKeyLength		= 55;

	private Color				m_default_color		= Color.WHITE;
	private Color				m_current_color		= m_default_color;

	public GenericKey(String [] sID, int iOctave)
	{
		Dimension dim = new Dimension(m_iKeyWidth, m_iKeyLength);

		this.m_sArrID = sID;
		this.m_iOctave = iOctave;

		this.setMinimumSize(dim);
		this.setPreferredSize(dim);
		this.setMaximumSize(dim);

		this.setSize(m_iKeyWidth, m_iKeyLength);

		this.addMouseListener(this);
				
		this.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
	}
	
	public void press_key()
	{
		color_key(KEY_DOWN);				
	}

	public void release_key()
	{
		color_key(KEY_UP);
	}

	public int getKeyWidth()
	{
		return m_iKeyWidth;
	}

	public int getKeyHeight()
	{
		return m_iKeyLength;
	}

	protected void setKeyWidth(int iWidth)
	{
		m_iKeyWidth = iWidth;
	}

	protected void setKeyHeight(int iHeight)
	{
		m_iKeyLength = iHeight;
	}

	protected void setCurrentColor(Color newColor)
	{
		m_current_color = newColor;
	}

	protected void setDefaultColor(Color newColor)
	{
		m_default_color = newColor;
	}

	protected Color getCurrentColor()
	{
		return m_current_color;
	}

	protected Color getDefaultColor()
	{
		return m_default_color;
	}

	private void color_key(boolean bKeyState)
	{
		if (bKeyState == KEY_DOWN)
		{
			m_current_color = Color.cyan;
		}
		else
		{
			m_current_color = m_default_color;
		}

		this.repaint();
	}

	public void paint(Graphics g)
	{
		super.paint(g);

		drawKey(g);
	}

	public void drawKey(Graphics g)
	{
	}

	public void mouseClicked(MouseEvent arg0)
	{
		log.debug("MouseClick");
		//KeyBoard kb = (KeyBoard)this.getParent();
		//kb.PlayNote(new GenericNote(this.m_sArrID, this.m_iOctave));			
	}

	public void mouseEntered(MouseEvent arg0)
	{		
		if ( (arg0.getModifiers() & MouseEvent.BUTTON1_MASK) == MouseEvent.BUTTON1_MASK)
			press_key();
	}

	public void mouseExited(MouseEvent arg0)
	{
		release_key();
	}

	public void mousePressed(MouseEvent arg0)
	{
		press_key();
	}

	public void mouseReleased(MouseEvent arg0)
	{
		release_key();
	}

}

