package nr.midi;

import nr.music.Chord;
import nr.music.Tone;

public class MidiReceiverEvent {
	public enum Type {NOTE,CHORD};
	private Type type;
	private Chord chord;
	private Tone note;
	

	public MidiReceiverEvent(Tone note) {
		type = Type.NOTE;
		this.note = note;
	}

	public MidiReceiverEvent(Chord chord) {
		type = Type.CHORD;
		this.chord = chord;
	}

	public Type getType() {
		return type;
	}

	public Chord getChord() {
		return chord;
	}

	public Tone getNote() {
		return note;
	}
	
	@Override
	public String toString() {
		return "MidiReceiverEvent[type:" + getType() + ", chord:" + getChord() + ", note:" + getNote() + "]";
	}
	

}
