package nr.music;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

public class Interval {
	private static HashMap<String, Integer> nameHalftoneTranslator = new HashMap<String, Integer>();
	static {
		nameHalftoneTranslator.put("1", new Integer(0));
		nameHalftoneTranslator.put("b2", new Integer(1));
		nameHalftoneTranslator.put("2", new Integer(2));
		nameHalftoneTranslator.put("#2", new Integer(3));
		nameHalftoneTranslator.put("b3", new Integer(3));
		nameHalftoneTranslator.put("3", new Integer(4));
		nameHalftoneTranslator.put("#3", new Integer(5));
		nameHalftoneTranslator.put("b4", new Integer(4));
		nameHalftoneTranslator.put("4", new Integer(5));
		nameHalftoneTranslator.put("#4", new Integer(6));
		nameHalftoneTranslator.put("b5", new Integer(6));
		nameHalftoneTranslator.put("5", new Integer(7));
		nameHalftoneTranslator.put("#5", new Integer(8));
		nameHalftoneTranslator.put("b6", new Integer(8));
		nameHalftoneTranslator.put("6", new Integer(9));
		nameHalftoneTranslator.put("#6", new Integer(10));
		nameHalftoneTranslator.put("b7", new Integer(10));
		nameHalftoneTranslator.put("7", new Integer(11));
		nameHalftoneTranslator.put("#7", new Integer(12));
		nameHalftoneTranslator.put("b8", new Integer(11));
		
		nameHalftoneTranslator.put("8", new Integer(12));		
		nameHalftoneTranslator.put("#8", new Integer(13));
		nameHalftoneTranslator.put("b9", new Integer(13));
		nameHalftoneTranslator.put("9", new Integer(14));
		nameHalftoneTranslator.put("#9", new Integer(15));
		nameHalftoneTranslator.put("b10", new Integer(15));
		nameHalftoneTranslator.put("10", new Integer(16));
		nameHalftoneTranslator.put("#10", new Integer(17));
		nameHalftoneTranslator.put("b11", new Integer(16));
		nameHalftoneTranslator.put("11", new Integer(17));
		nameHalftoneTranslator.put("#11", new Integer(18));
		nameHalftoneTranslator.put("b12", new Integer(18));
		nameHalftoneTranslator.put("12", new Integer(19));
		nameHalftoneTranslator.put("#12", new Integer(20));
		nameHalftoneTranslator.put("b13", new Integer(20));
		nameHalftoneTranslator.put("13", new Integer(21));
		nameHalftoneTranslator.put("#13", new Integer(22));
		nameHalftoneTranslator.put("b14", new Integer(22));
		nameHalftoneTranslator.put("14", new Integer(23));
		nameHalftoneTranslator.put("#14", new Integer(24));
		nameHalftoneTranslator.put("b15", new Integer(23));
		
		nameHalftoneTranslator.put("15", new Integer(24));
		nameHalftoneTranslator.put("#15", new Integer(25));
		nameHalftoneTranslator.put("b16", new Integer(25));
		nameHalftoneTranslator.put("16", new Integer(26));
		nameHalftoneTranslator.put("#16", new Integer(27));
		nameHalftoneTranslator.put("b17", new Integer(27));
		nameHalftoneTranslator.put("17", new Integer(28));
		nameHalftoneTranslator.put("#17", new Integer(29));
		nameHalftoneTranslator.put("b18", new Integer(28));
		nameHalftoneTranslator.put("18", new Integer(29));
		nameHalftoneTranslator.put("#18", new Integer(30));
		nameHalftoneTranslator.put("b19", new Integer(30));
		nameHalftoneTranslator.put("19", new Integer(31));
		nameHalftoneTranslator.put("#19", new Integer(32));
		nameHalftoneTranslator.put("b20", new Integer(32));
		nameHalftoneTranslator.put("20", new Integer(33));
		nameHalftoneTranslator.put("#20", new Integer(34));
		nameHalftoneTranslator.put("b21", new Integer(34));
		nameHalftoneTranslator.put("21", new Integer(35));
		nameHalftoneTranslator.put("#21", new Integer(36));	
		nameHalftoneTranslator.put("b22", new Integer(36));
		
		nameHalftoneTranslator.put("22", new Integer(37));
		nameHalftoneTranslator.put("#22", new Integer(38));
		nameHalftoneTranslator.put("b23", new Integer(38));
		nameHalftoneTranslator.put("23", new Integer(39));
		nameHalftoneTranslator.put("#23", new Integer(40));
		nameHalftoneTranslator.put("b24", new Integer(40));
		nameHalftoneTranslator.put("24", new Integer(41));
		nameHalftoneTranslator.put("#24", new Integer(42));
		nameHalftoneTranslator.put("b25", new Integer(42));
		nameHalftoneTranslator.put("25", new Integer(43));
		nameHalftoneTranslator.put("#25", new Integer(44));
		nameHalftoneTranslator.put("b26", new Integer(44));
		nameHalftoneTranslator.put("26", new Integer(45));
		nameHalftoneTranslator.put("#26", new Integer(46));
		nameHalftoneTranslator.put("b27", new Integer(46));
		nameHalftoneTranslator.put("27", new Integer(47));
		nameHalftoneTranslator.put("#27", new Integer(48));
		nameHalftoneTranslator.put("b28", new Integer(48));
		nameHalftoneTranslator.put("28", new Integer(49));
		nameHalftoneTranslator.put("#28", new Integer(50));
		nameHalftoneTranslator.put("b29", new Integer(50));
		
		nameHalftoneTranslator.put("29", new Integer(51));
		nameHalftoneTranslator.put("#29", new Integer(52));
		nameHalftoneTranslator.put("b30", new Integer(52));
		nameHalftoneTranslator.put("30", new Integer(53));
		nameHalftoneTranslator.put("#30", new Integer(54));
		nameHalftoneTranslator.put("b31", new Integer(54));
		nameHalftoneTranslator.put("31", new Integer(55));
		nameHalftoneTranslator.put("#31", new Integer(56));
		nameHalftoneTranslator.put("#32", new Integer(56));
				
	}

	int halfTones;
	private String name;
	
	public Interval(String name) {
		this.name = name;
		Integer halfs = nameHalftoneTranslator.get(name);
		if(halfs != null) {
			halfTones = halfs.intValue();
		}else {
			throw new IllegalArgumentException("undefined name for Interval: " + name);
		}
	}
	
	public Interval(int halfTones) {
		this.halfTones = halfTones;
		Integer halfs = new Integer(halfTones % nameHalftoneTranslator.size());
		Set<String> names = nameHalftoneTranslator.keySet();
		Iterator<String> iter = names.iterator();
		while (iter.hasNext()) {
			String keyName = iter.next();
			Integer integer = nameHalftoneTranslator.get(keyName);
			if(integer.equals(halfs)){
				this.name = keyName;
				break;
			}
		}
		if(this.name == null) {
			throw new IllegalArgumentException("undefined amount of halftones:" + halfTones);
		}
	}
	
	public int getHalfTones() {
		return halfTones;
	}
	
	@Override
	public String toString() {
		return super.toString() + "[name:" + name + ", halfTones:" + halfTones + "]";
	}
}
