package nr.music.chordprovider.old;

import java.util.ArrayList;
import java.util.Iterator;

import nr.music.Chord;
import nr.music.Tone.Sign;
import nr.music.chordprovider.CadenceProvider.Mode;
import nr.music.chordprovider.ChordProviderEvent;
import nr.music.chordprovider.ChordProviderListener;
import nr.music.chordprovider.KeyProvider.KeySequence;

public abstract class AbstractChordProvider //implements IChordProviders 
{
//	static private Category log = Category.getInstance(AbstractChordProvider.class);
	
	private Sign sign = Sign.FLAT;
	private Mode mode = Mode.SEQUENTIAL;
	private KeySequence keySequence = KeySequence.CHROMATIC; 
	
	private ArrayList<ChordProviderListener> listeners = new ArrayList<ChordProviderListener>();

	public void addListener(ChordProviderListener listener) {
		listeners.add(listener);
	}
	
	public void removeListener(ChordProviderListener listener) {
		listeners.remove(listener);
	}

	protected void notifyChordChanged(Chord chord, boolean isLast) {
		ChordProviderEvent event = new ChordProviderEvent(chord, isLast);
		Iterator<ChordProviderListener> iter = listeners.iterator();
		while (iter.hasNext()) {
			ChordProviderListener listener = iter.next();
			listener.chordChanged(event);
		}
	}

	public Sign getSign() {
		return sign;
	}
	public void setSign(Sign sign) {
		this.sign = sign;
	}
	public KeySequence getKeySequence() {
		return keySequence;
	}
	public void setKeySequence(KeySequence keySequence) {
		this.keySequence = keySequence;
	}
	public Mode getCadenceProviderMode() {
		return mode;
	}
	public void setCadenceProviderMode(Mode mode) {
		this.mode = mode;
	}
	
}
